#ifndef TEST_WEBSITE_SRC_MODULE_JSON_LIBJSONINCPP_INNER_STORAGE_H
#define TEST_WEBSITE_SRC_MODULE_JSON_LIBJSONINCPP_INNER_STORAGE_H

/* DO NOT EXPORT THIS FILE */

#include "jsonobj.h"

namespace json {
    struct ArrayData {
        std::vector<JSON> data;
        /* This field will be used in destructor to iterat over children. Destructor must not be
         * recursive and must not allocate memory */
        std::vector<JSON>::iterator it;
        /* Parent (used only in destructor) */
        void* wayback = NULL; // Null means no parent (end of recursion)

        ~ArrayData();
    };

    struct DictionaryData {
        std::map<std::string, JSON> data;
        /* Again, destructors can't allocate a heap stack by themselves (it would be too late), JSON has to take
         * care of it NOW */
        std::map<std::string, JSON>::iterator it;
        void* wayback = NULL; // Same as ArrayDaya::wayback

        ~DictionaryData();
    };

    void setup_nr_iterators(const JSON& obj_child, void* wayback) noexcept;

    void nullify(JSON& obj) noexcept;

    void copy_json(JSON& destination, const JSON& source);

    bool eq_compare_json(const JSON& A, const JSON& B) noexcept;

    bool is_subtree_of(const JSON& A, const JSON& B) noexcept;
}

// #define get_wayback(data) static_cast<JSON*&>


#endif
