#include "integer.h"
#include <string.h>

namespace json {
    Integer::Integer(int64_t v): value(v) {}

    /* Throw bad_alloc. Very safe */
    void copy_horror(Integer& i, const char* other_horror) {
        if (!other_horror)
            return;
        size_t n = strlen(other_horror);
        i.uncomprehendable_horror = (char*)calloc(n + 1, 1);
        if (!i.uncomprehendable_horror)
            throw std::bad_alloc();
        memcpy(i.uncomprehendable_horror, other_horror, n);
    }

    Integer::Integer(const char *terrifyingly_big_string) {
        copy_horror(*this, terrifyingly_big_string);
    }

    Integer::Integer(const Integer &other): value(other.value) {
        copy_horror(*this, other.uncomprehendable_horror);
    }

    Integer & Integer::operator=(const Integer &other) {
        value = other.value;
        free(uncomprehendable_horror); uncomprehendable_horror = NULL;
        copy_horror(*this, other.uncomprehendable_horror);
        return *this;
    }

    std::string Integer::to_string() const {
        if (uncomprehendable_horror) {
            return std::string(uncomprehendable_horror);
        }
        return std::to_string(value);
    }

    int64_t Integer::get_int() const {
        if (uncomprehendable_horror)
            return INT64_MAX;
        return value;
    }

    Integer::~Integer() {
        free(uncomprehendable_horror);
    }

    bool Integer::operator==(const Integer &other) const {
        if (uncomprehendable_horror || other.uncomprehendable_horror)
            return to_string() == other.to_string();
        return value == other.value;
    }

    bool Integer::operator!=(const Integer &other) const {
        return !(*this == other);
    }
}
