#ifndef TEST_WEBSITE_SRC_MODULE_JSON_LIBJSONINCPP_INTEGER_H
#define TEST_WEBSITE_SRC_MODULE_JSON_LIBJSONINCPP_INTEGER_H

#include <stdint.h>
#include <string>
#include <stdexcept>

namespace json {
    struct Integer {
        int64_t value = 0;
        /* JSON specification allows enormously big enormously precise float values. I don't want to handle this
         * nonsense */
        char* uncomprehendable_horror = NULL;

        /* Only these members should be accessed */
        Integer() = default;
        explicit Integer(int64_t v);
        explicit Integer(const char* terrifyingly_big_string);
        Integer(const Integer& other);
        Integer& operator=(const Integer& other);

        std::string to_string() const;

        int64_t get_int() const;

        ~Integer();

        bool operator==(const Integer& other) const;
        bool operator!=(const Integer& other) const;
    };
}

#endif
