#ifndef TEST_WEBSITE_SRC_MODULE_JSON_LIBJSONINCPP_STRING_REPRESENTATION_H
#define TEST_WEBSITE_SRC_MODULE_JSON_LIBJSONINCPP_STRING_REPRESENTATION_H

#include "jsonobj.h"

namespace json {
    constexpr uint32_t print_compact = 1;
    constexpr uint32_t print_pretty = 0;

    /* Throws json::misuse if obj contains non-utf8 strings. Throws std::bad_alloc */
    std::string generate_str(const JSON &obj, uint32_t mode);

    struct WrongSyntax {
        size_t line;
        size_t column;
    };

    /* Returns negative on error. Fills ret_error on syntax error. Still can throw std::bad_alloc
     * ret_ans should be passed as null symbol
     */
    int parse_str(const std::string& text, JSON& ret_ans, WrongSyntax& ret_error);

    /* Throws json::misuse when parsing fails */
    JSON parse_str_flawless(const std::string& text);
}

#endif
